﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Security.Cryptography.X509Certificates;

namespace Org.Eurekaa.PDF.iSafePDF
{
    public partial class CertificateDialog : Form
    {
        public CertificateDialog()
        {
            InitializeComponent();
        }

        private void browseBtn_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.OpenFileDialog openFile;
            openFile = new System.Windows.Forms.OpenFileDialog();
            openFile.Filter = "Certificate files (*.pfx)|*.pfx|Certificate files (*.p12)|*.p12";
            openFile.Title = "Select a file";
            if (openFile.ShowDialog() != DialogResult.OK)
                return;

            certTextBox.Text = openFile.FileName;


            certsListBox.Enabled = false;

            certsListBox.SelectedItem = null;

            certsListBox.Enabled = true;

        }


        private void OKBtn_Click(object sender, EventArgs e)
        {

        }

        private void CertificateDialog_Load(object sender, EventArgs e)
        {
            string strLengestText = "";
            X509Store store = new X509Store(StoreName.My);
            store.Open(OpenFlags.ReadOnly);
            foreach (X509Certificate2 cert in store.Certificates)
            {
                if (cert.ToString().Length > strLengestText.Length)
                    strLengestText = cert.ToString();
                certsListBox.Items.Add(cert);
            }
            // Display a horizontal scroll bar.
            certsListBox.HorizontalScrollbar = true;

            // Create a Graphics object to use when determining the size of the largest item in the ListBox.
            Graphics g = certsListBox.CreateGraphics();
            strLengestText = strLengestText.Replace("\r", "").Replace("\n", "");
            // Determine the size for HorizontalExtent using the MeasureString method using the last item in the list.
            int hzSize = (int)g.MeasureString(strLengestText, certsListBox.Font).Width;
            // Set the HorizontalExtent property.
            certsListBox.HorizontalExtent = hzSize;
        }

        private void certsListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if ((sender as ListBox).Enabled)
                certTextBox.Text = string.Empty;
        }

        private void certsListBox_MouseMove(object sender, MouseEventArgs e)
        {
             // Get the index for the item being hovered.
             int index = certsListBox.IndexFromPoint(e.Location);

             // Check if the index is valid.
             if (index != -1 && index < certsListBox.Items.Count)
             {
                  // Check if the ToolTip's text isn't already the one
                  // we are now processing.
                  if (toolTip1.GetToolTip(certsListBox) != certsListBox.Items[index].ToString())
                  {
                       // If it isn't, then a new item needs to be
                       // displayed on the toolTip. Update it.
                       toolTip1.SetToolTip(certsListBox, certsListBox.Items[index].ToString());
                  }
             }
        }
    }
}
